View Issue Details

IDProjectCategoryView StatusLast Update
0002438ScribusInternalpublic2016-11-17 11:25
ReporterringercAssigned To 
PrioritynormalSeveritymajorReproducibilityalways
Status acknowledgedResolutionopen 
PlatformanyOSanyOS Versionany
Product Version1.3 
Target VersionFixed in Version 
Summary0002438: Metabug: Cases of extreme memory use
DescriptionAnother bug to collect information about where we're using problematic amounts of memory working on things that probably should not require that much memory.
Additional InformationSee the whole list of metabugs: http://wiki.scribus.net/index.php/Metabugs
TagsNo tags attached.
Patch

Relationships

related to 0002405 closedjghali Signal 6 crashes when exporting PDFs. 
related to 0001662 closedfschmid Scribus eats ALL my memory and then gets killed by the oom-killer 
related to 0002382 acknowledged Metabug: Code quality, structure, readability 
related to 0002221 closedfschmid scribus crash with signal 0000006 or complete freeze while trying to import complex svg files 
related to 0003716 closedavox Scribus crashes on PDF export and leaves sla file uneditable 
related to 0005262 closedjghali Scribus crashes due to Signal 0000006 on printing 
parent of 0002262 confirmed Crash when build PDF-file from a A0 sheet 
parent of 0004024 confirmed Get Image Preview too slow for production machines, for magazine/publication etc - doesn't handle big tiffs well 
parent of 0004189 confirmed [OBSOLETE] big picture crashes Scribus on PDF export 
parent of 0004197 closedfschmid eps svg import - program crash 
parent of 0004318 closedplinnell PNG. problem 
parent of 0004076 closedcbradney large document takes several minutes to load 
parent of 0004506 closedjghali high number of images leads to a Out of Memory error and crash, with whole system instability 
parent of 0004513 closedale 100% cpu usage while aligning the text 
parent of 0004525 closed Taking system memory by all document pages. 
parent of 0005239 closedplinnell Very slow performance at selecting objects and high CPU usage 
parent of 0004520 assignedjghali Crash while placing multiple large JPEG images 
parent of 0005490 closedplinnell When I attempt to save the file as a pdf it crashes Scribus 
parent of 0005534 confirmed Exported PDF without fonts... larger 
parent of 0012617 closedfschmid Scribus slows down after applying drop shadow to image frames 
parent of 0012513 closedfschmid Signitficant data-entry speed issue when the page contains a shaded object 
parent of 0009607 assignedHerm Scribus has a really hard time loading documents exceeding 20 pages with lot's of render frames (lilypond) 
parent of 0005797 confirmed big text files import crashes Scribus 
parent of 0002733 acknowledged Scribus crashes when formatting large amounts of text In Story Editor 
parent of 0009826 assignedjghali [BUG] images load twice during opening SLA file when CMS enabled 
parent of 0001036 confirmed Severe performance problem on documents with very large number of linked frames 
parent of 0012825 confirmed Severe performance issue with layers having special blend modes 
parent of 0004890 closed do not load pictures that are not selected to be displayed to save memory => crash 
parent of 0013388 closedjghali Generating a large PDF takes a LONG time 
parent of 0013207 new Story Editor loses text on Scribus 1.4.2 
parent of 0013807 new Display chaos or crash for "big" documents 
parent of 0006509 closed Pasting text in Story Editor is very slow 
related to 0003406 closedringerc free memory used by large files 
related to 0004522 closedplinnell crashing when exporting to PDF 
related to 0005558 closedavox 1.2 files opened in 1.3.4cvs almost uneditable due to performance issues 
related to 0005517 closedjghali Crash when exporting PDF (invalid memory reference) 
related to 0008308 feedback [patch] unload unused images from RAM and restore them silently on the next access 
Not all the children of this issue are yet resolved or closed.

Activities

ringerc

2005-08-14 15:21

reporter   ~0006118

In addition to the above, image export also appears to use extremely large amounts of RAM for large images, due to the use of QImage (and the resultant large in-memory bitmap).

plinnell

2005-10-02 21:11

viewer   ~0006862

bumping

ringerc

2006-01-05 09:15

reporter   ~0007928

We use QString in lots of highly inappropriate places. Most notably is using a QString as a memory buffer(!!!) for images.

This needs to be fixed, as it's potentially very inefficient, is a real misuse of QString, and is a sign we actually need a better container for CMYK images (perhaps by giving ScImage the ability to store CMYK image data?).

ringerc

2006-01-05 09:18

reporter   ~0007929

Last edited: 2006-01-05 13:02

We build a PDF document as an in-memory string before streaming it out to disk (CORRECTION: No, we don't, in fact most parts are streamed to disk very promptly.)

Some objects are built as in-memory strings, and then written out. These objects are often mutltiply reprocessed, and are frequently represented as QStrings well before the final write to PDF.

QString probably isn't the best data type anyway, since we actually usually want a byte string. We're abusing QString by shoving characters in it that have the same ordinal values as the bytes we want to store, then writing the document out with QString::latin1() to preserve byte values.

Issue History

Date Modified Username Field Change
2005-08-14 15:11 ringerc New Issue
2005-08-14 15:12 ringerc Relationship added related to 0002405
2005-08-14 15:12 ringerc Status new => confirmed
2005-08-14 15:15 ringerc Relationship added related to 0001662
2005-08-14 15:16 ringerc Relationship added related to 0002262
2005-08-14 15:21 ringerc Note Added: 0006118
2005-08-14 15:23 ringerc Relationship added related to 0002382
2005-08-27 03:21 ringerc Relationship added related to 0002221
2005-10-02 21:11 plinnell Note Added: 0006862
2005-10-02 21:11 plinnell Product Version 1.3.1cvs => 1.3.2cvs
2006-01-05 09:15 ringerc Note Added: 0007928
2006-01-05 09:18 ringerc Note Added: 0007929
2006-01-05 13:02 ringerc Note Edited: 0007929
2006-03-14 12:22 ringerc Relationship added related to 0003406
2006-07-02 22:11 mhanski Additional Information Updated
2006-07-17 08:09 ringerc Relationship added related to 0004024
2006-08-16 15:43 ringerc Relationship added related to 0003716
2006-08-28 20:36 jo-hannes Relationship added parent of 0004189
2006-09-01 06:35 jghali Relationship added parent of 0004197
2006-09-29 10:53 ringerc Relationship added parent of 0004318
2006-10-28 10:30 mhanski Relationship added parent of 0004076
2006-11-09 16:21 mhanski Relationship added parent of 0004506
2006-11-09 16:24 mhanski OS Fedora Core => any
2006-11-09 16:24 mhanski OS Version 3 => any
2006-11-09 16:24 mhanski Platform x86 Linux => any
2006-11-09 16:24 mhanski Product Version 1.3.2cvs => 1.3
2006-11-11 21:58 mhanski Relationship added parent of 0004513
2006-11-13 22:46 mhanski Relationship added related to 0004522
2006-11-14 09:45 mhanski Relationship added parent of 0004525
2007-01-25 09:06 mhanski Relationship added parent of 0005239
2007-01-31 23:14 jghali Relationship added related to 0004520
2007-01-31 23:14 jghali Relationship added related to 0005262
2007-02-26 16:23 mhanski Relationship added parent of 0005393
2007-03-02 22:32 plinnell Relationship deleted parent of 0005393
2007-03-28 07:00 mhanski Relationship added parent of 0005490
2007-04-06 22:07 mhanski Relationship added child of 0005534
2007-04-06 22:15 mhanski Relationship deleted child of 0005534
2007-04-06 22:16 mhanski Relationship added related to 0005534
2007-04-15 07:54 mhanski Relationship added related to 0005558
2007-04-26 19:30 ringerc Relationship added related to 0005517
2014-07-09 15:46 Kunda Status confirmed => acknowledged
2014-08-18 16:17 Kunda Relationship added parent of 0012617
2014-08-18 16:21 Kunda Relationship added related to 0008308
2014-09-13 13:29 Kunda Relationship added related to 0012513
2014-09-13 13:35 Kunda Relationship added parent of 0009607
2014-09-13 13:37 Kunda Relationship replaced parent of 0012513
2014-09-13 13:38 Kunda Relationship replaced parent of 0004024
2014-09-13 13:40 Kunda Relationship replaced parent of 0004520
2014-09-13 13:40 Kunda Relationship replaced parent of 0005534
2014-09-13 13:42 Kunda Relationship replaced parent of 0002262
2014-09-13 13:45 Kunda Relationship added parent of 0005797
2014-09-13 13:47 Kunda Relationship added parent of 0002733
2014-09-18 12:37 Kunda Relationship added parent of 0009826
2014-09-18 22:06 Kunda Relationship added parent of 0001036
2015-04-29 01:30 Kunda Relationship added parent of 0012825
2015-04-29 01:50 Kunda Relationship added parent of 0004890
2015-10-02 22:50 Kunda Relationship added parent of 0013388
2016-03-07 13:43 Kunda Relationship added related to 0013207
2016-03-07 13:44 Kunda Relationship replaced parent of 0013207
2016-03-15 12:48 Kunda Relationship added parent of 0013807
2016-11-17 11:25 Kunda Relationship added parent of 0006509